首页 > 学院 > 开发设计 > 正文

Codeforces 672D Robin Hood【思维+二分】这题思路有点劲啊

2019-11-14 08:48:04
字体:
来源:转载
供稿:网友

D. Robin Hoodtime limit per test1 secondmemory limit per test256 megabytesinputstandard inputoutputstandard output

We all know the imPRessive story of Robin Hood. Robin Hood uses his archery skills and his wits to steal the money from rich, and return it to the poor.

There are n citizens in Kekoland, each person hasci coins. Each day, Robin Hood will take exactly1 coin from the richest person in the city and he will give it to the poorest person (poorest person right after taking richest's1 coin). In case the choice is not unique, he will select one among them at random. Sadly, Robin Hood is old and want to retire ink days. He decided to spend these last days with helping poor people.

After taking his money are taken by Robin Hood richest person may become poorest person as well, and it might even happen that Robin Hood will give his money back. For example if all people have same number of coins, then next day they will have same number of coins too.

Your task is to find the difference between richest and poorest persons wealth afterk days. Note that the choosing at random among richest and poorest doesn't affect the answer.

Input

The first line of the input contains two integers n andk (1 ≤ n ≤ 500 000, 0 ≤ k ≤ 109) — the number of citizens in Kekoland and the number of days left till Robin Hood's retirement.

The second line contains n integers, thei-th of them is ci (1 ≤ ci ≤ 109) — initial wealth of the i-th person.

Output

Print a single line containing the difference between richest and poorest peoples wealth.

ExamplesInput
4 11 1 4 2Output
2Input
3 12 2 2Output
0Note

Lets look at how wealth changes through day in the first sample.

[1, 1, 4, 2] [2, 1, 3, 2] or [1, 2, 3, 2]

So the answer is 3 - 1 = 2

In second sample wealth will remain the same for each person.

题目大意:

给你N个人的财富值,每天最有钱的人会给最没钱的人一块钱,问K天之后,最穷的人和最富有的人之间差多少钱。

思路:

1、virtual contest过程中一直在二分差值,然后发现最小值和最大值的问题不是很好处理,一直在想一个科学的连续二分的方式去枚举出最小值和最大值。以一种二分套二分的方式去解,以失败告终。

2、正解是这样的:①因为时间越长(天数经过的越多),最大值就会越小,同理,最小值就会越大(所以这就是智障的去二分差值的理由?尼玛本质是最大值最小值的变化好嘛,为毛要想到差值上去.......)那么我们二分一个最小值,接下来二分一个最大值。

②判定二分的过程很简单,对于枚举最小值的时候,如果需要的最少天数小于等于k,那么就加大最小值,否则减小最小值即可。那么二分枚举最大值的时候同理即可。

③问题的坑点在于维护上下界。对于总值:sum,如果sum%n==0,那么最小值的上界就是sum/n,最大值的下界也是sum/n.当sum%n!=0的时候,最小值的上界还是sum/n,但是最大值的下界应该是sum/n+1.这里被坑了......................

3、过程维护最终解,细心一些没有别的了。

Ac代码:

#include<stdio.h>#include<string.h>#include<algorithm>using namespace std;#define ll __int64ll a[500500];ll n,m;int Slove(ll mid){    ll sum=0;    for(int i=1;i<=n;i++)    {        if(a[i]<mid)sum+=mid-a[i];    }    if(sum<=m)return 1;    else return 0;}int Slove2(ll mid){    ll sum=0;    for(int i=n;i>=1;i--)    {        if(a[i]>mid)sum+=abs(mid-a[i]);    }    if(sum<=m)return 1;    else return 0;}int main(){    while(~scanf("%I64d%I64d",&n,&m))    {        ll sum=0;        ll up,down;        for(int i=1;i<=n;i++)        {            scanf("%I64d",&a[i]);            sum+=a[i];        }        if(sum%n==0)up=down=sum/n;        else up=sum/n,down=up+1;        sort(a+1,a+1+n);        ll l=0;        ll r=up;        ll minn=-1;        while(r-l>=0)        {            ll mid=(l+r)/2;            if(Slove(mid)==1)            {                minn=mid;                l=mid+1;            }            else r=mid-1;        }        l=down;        r=1000000000;        ll maxn=-1;        while(r-l>=0)        {            ll mid=(l+r)/2;            if(Slove2(mid)==1)            {                maxn=mid;                r=mid-1;            }            else l=mid+1;        }        printf("%I64d/n",maxn-minn);    }}


发表评论 共有条评论
用户名: 密码:
验证码: 匿名发表